#version 300 es
precision mediump float;

uniform ModelData//copy from vertex shader
{
    mat4 mMatrix;
    vec4 mColor;
    vec2 otherFloats;//separate floats don't work on nexus 5 for some reason
    //0 useLighting
    //1 forceTexture
} modelData;

uniform vec3 toLight;
uniform sampler2D u_texture;

in vec2 interpolatedUV;
in vec3 interpolatedNormal;
in vec4 interpolatedColour;
in float interpolatedTextured;

out vec4 fragColor;

void main() {
    if(modelData.otherFloats[1] != 0.0 || interpolatedTextured == 1.0){
        vec4 textureColour = texture(u_texture, interpolatedUV);
        //if(textureColour[0] != 1.0 && textureColour[0] != 0.0 && textureColour[0] == textureColour[3])
        //    fragColor = vec4(1, 0, 0, 1);
        //else
            fragColor = textureColour * interpolatedColour * modelData.mColor;
    } else
        fragColor = interpolatedColour * modelData.mColor;
    if(modelData.otherFloats[0] != 0.0){
        float lightStrength = dot(normalize(toLight), normalize(interpolatedNormal));
        if(lightStrength < 0.0)
            lightStrength = 0.0;

        vec4 color = pow(fragColor, vec4(2.0));
        //vec4 color = fragColor;
        float a = color.a;
        //fragColor = vec4(interpolatedNormal,1);
        color = color * (0.5 + 0.5 * lightStrength);
        color.a = a;
        fragColor = pow(color, vec4(0.5));
        //fragColor = color;
    }
}