#version 300 es

uniform ModelData//copy from vertex shader
{
    mat4 mMatrix;
    vec4 mColor;
    vec2 otherFloats;//separate floats don't work on nexus 5 for some reason
    //0 useLighting
    //1 forceTexture
} modelData;

uniform mat4 vpMatrix;

in vec4 in_Position;
in vec2 in_UV;
in vec3 in_Normal;
in vec4 in_Colour;
in float in_Textured;

out vec2 interpolatedUV;
out vec3 interpolatedNormal;
out vec4 interpolatedColour;
out float interpolatedTextured;

void main() {
    mat4 mvp =  vpMatrix * modelData.mMatrix;
    gl_Position = mvp * in_Position;

    interpolatedUV = in_UV;
    interpolatedColour = in_Colour;
    interpolatedTextured = in_Textured;
    if(modelData.otherFloats[0] == 0.0)
        interpolatedNormal = vec3(0, 0, 1);
    else {
        mat3 nMatrix = mat3(modelData.mMatrix);
        //doesn't work right when a model isn't scaled equally on x y and z
        //good enough here
        nMatrix[0] = normalize(nMatrix[0]);
        nMatrix[1] = normalize(nMatrix[1]);
        nMatrix[2] = normalize(nMatrix[2]);
        interpolatedNormal = nMatrix * in_Normal;
    }
}